-- 1
SELECT V.login, firstname, lastname, loyalty_points
FROM Visitor as V
INNER JOIN Fidelity as F ON V.login = F.login
WHERE loyalty_points < 50;

-- 2
SELECT V.login, firstname, lastname, loyalty_points
FROM Visitor as V
LEFT JOIN Fidelity as F ON V.login = F.login
WHERE IFNULL(loyalty_points,0) < 50 AND V.login LIKE "l%";

SELECT V.login, firstname, lastname, loyalty_points
FROM Visitor as V
LEFT JOIN Fidelity as F ON V.login = F.login
WHERE (loyalty_points < 50 OR loyalty_points IS NULL) AND V.login GLOB "l*";

-- 3
SELECT firstname, lastname, loyalty_points
FROM Visitor as V
INNER JOIN Fidelity as F ON V.login = F.login;

-- 4
SELECT * 
FROM Conference
WHERE title IN ("databases", "microservices");

SELECT * 
FROM Conference
WHERE title <> "databases" OR title IS "microservices";

-- 5
SELECT title
FROM Topic;

-- 6
SELECT DISTINCT title
FROM Conference;

-- 7
-- non standard, sqlite only
SELECT *
FROM Visitor 
INTERSECT
SELECT *
FROM Speaker;

-- standard
SELECT *
FROM Visitor 
INNER JOIN Speaker ON Visitor.login = Speaker.login;

-- sous-requête IN
SELECT *
FROM Visitor
WHERE login IN (
    SELECT login FROM Speaker
);

-- sous-requête EXISTS
SELECT *
FROM Visitor
WHERE EXISTS  (
    SELECT login FROM Speaker
    WHERE Speaker.login = Visitor.login
);


-- 8
SELECT *
FROM Speaker
WHERE login NOT IN (
    SELECT login FROM Visitor
);

-- 9
SELECT Topic.title, COUNT(id_conference)
FROM Topic
LEFT JOIN Conference ON Conference.title = Topic.title
GROUP BY Topic.title;

-- 10
SELECT *
FROM Visitor 
WHERE login NOT IN (SELECT login FROM Registration);

SELECT *
FROM Visitor 
LEFT JOIN Registration ON Visitor.login = Registration.login
WHERE id_conference IS NULL;

-- 11
SELECT V.login, firstname, lastname, COUNT(id_conference)
FROM Visitor AS V
LEFT JOIN Registration AS R ON V.login = R.login
GROUP BY V.login;


-- 12
SELECT lastname, firstname, start_date, end_date, name
FROM Speaker AS S
INNER JOIN Stay AS ST ON S.login = ST.login
INNER JOIN Hotel AS H ON ST.id_hotel = H.id_hotel;

-- 13
SELECT T.title, COUNT(DISTINCT login)
FROM Topic AS T
LEFT JOIN Conference AS C ON T.title = C.title
LEFT JOIN Registration AS R ON C.id_conference = R.id_conference
GROUP BY T.title;

-- 14
SELECT C.name, start_date, end_date,
( 
    SELECT COUNT(R.login) FROM Registration AS R 
    WHERE C.id_conference = R.id_conference 
) AS Visitors, 
( 
    SELECT COUNT(P.login) FROM Participation AS P 
    WHERE C.id_conference = P.id_conference 
) AS Speakers
FROM Conference AS C;
